Program Tablazat;
(*
  Feladat: a lncolt lists tbla-brzols tesztelse, azaz
           kulcshasonltsok szma s sikerek szma.
  Rszletesebben:
  1) Tblafeltlts vltetlen nevekkel.
  2) Tblban vlteten nevek keresse.
  3) Tblbl vlteten nevek trlse.
  Tovbbfejlesztse:
  generlt nevek visszakeresse.
*)
  Uses  Newdelay,Crt;

  {$i AltRutin.inc -- ltalnosan hasznlt rutinok}
  {$i Randnev.inc -- Vltetlen nv generlshoz}

  Const
    MaxN = 32;
    BN = 100; KN = 200; TN =100; {Beteend,keresend,trlend elemek szma}
  Type
    Kulcs = TNev;
    Elem  = TNev;
    ListaElemMut = ^ListaElem;
    ListaElem = Record kulcs:Kulcs; elem:Elem; kov:ListaElemMut End;
    Lista = Record fej:ListaElemMut; db:Word End;
    Index = 0..MaxN-1;
    Tabla = Array [Index] of Lista;
  Var
    t    : Tabla;
    i    : Integer;
    nev  : TNev;
    e    : Elem;
    siker: Boolean;
    kulcsHasonlitasok,
    sikerSzam: Integer;
    sorDb: Integer;    {a kpernyre kirt sorok szma}

  Function Hash(n:TNev):Index;
    Var
      i  :Integer;
      cim:Byte;
  Begin
    cim:=0;
    For i:=1 to Length(n) do cim:=cim XOR Ord(n[i]);
    Hash:=cim Mod MaxN;
  End;

  Procedure TablaUres(Var t:Tabla);
    Var
      i:Integer;
  Begin
    For i:=0 to MaxN-1 do
    Begin
      t[i].fej:=Nil; t[i].db:=0
    End;
  End;

  Procedure TablaKiir(t:Tabla);
    Var
      i   :Integer;
      minLH,
      maxLH,
      atlLH,  {minimlis,maximlis,tlagos listahossz}
      db  :Integer;
      hol :ListaElemMut;
  Begin
    UjLap('Tblzat -- kirs'+CrLf,-1); sorDb:=2;
    db:=0; atlLH:=0; minLH:=BN; maxLH:=0;
    For i:=0 to MaxN-1 do
    Begin
      Inc(atlLH,t[i].db);
      If minLh>t[i].db then minLH:=t[i].db;
      If maxLh<t[i].db then maxLH:=t[i].db;
      If t[i].db>1 then Inc(db,t[i].db-1);  {tkzsszm}
      Write(i:5,'(',t[i].db,'):');
      If t[i].fej<>Nil Then
      Begin
       hol:=t[i].fej;
        While hol^.kov<>Nil do
        Begin
          Write(hol^.kulcs,'/');
          hol:=hol^.kov;
        End;
        Write(hol^.kulcs);
      End;
      Writeln;
      If (i Mod 20)=19 then
      Begin
        UjLap('Tblzat -- kirs'+CrLf,-1); sorDb:=2;
      End;
    End;
    Writeln(CrLf,' sszes tblban lv elemek szma:',BN);
    Writeln(' sszes tkz elemek szma:',db);
    Write  (' Minimlis listahossz:',minLH:3);
    Write  (' Maximlis listahossz:',maxLH:3);
    Writeln(' Atlagos listahossz:',atlLH/MaxN:5:2);
    If (i Mod 20)<>19 then
    Begin
      BillreVar;
    End;
  End;

  Procedure Tablaba(Var t:Tabla; e:Elem);
    Var
      i:Integer;
      hol,
      te:ListaElemMut;
  Begin
    i:=Hash(e{kulcs});
    If WhereY>=20 then UjLap('Tblzat -- tblba flvtel'+CrLf,-1); sorDb:=2;
    Write(i:5,'(',t[i].db,') ');
    New(te); te^.kulcs:=e; te^.kov:=Nil;
    If t[i].fej=Nil then
    Begin
      t[i].fej:=te; t[i].db:=1;
    End
       Else
    Begin
      Inc(t[i].db);
      hol:=t[i].fej;
      While hol^.kov<>Nil do
      Begin
        Write(hol^.kulcs,'/');
        hol:=hol^.kov;
      End;
      Write(hol^.kulcs);
      hol^.kov:=te;
    End;
    Writeln;
    sorDb:=WhereY
  End;

  Procedure TablabolTorol(Var t:Tabla; k:Kulcs; Var van:Boolean);
    Var
      i  :Integer;
      elozo,
      hol:ListaElemMut;
  Begin
    If WhereY>=20 then UjLap('Tblzat -- tblbl trls'+CrLf,-1); sorDb:=2;
    Write('Trlm a(z) "',k,'"-t, ami a(z) ');
    i:=Hash(k);
    Writeln(i:5,'. index, ahol ',t[i].db,' elem van.');
    hol:=t[i].fej;
    If hol<>Nil then
    Begin
      Write('  Mgpedig: '); elozo:=Nil;
      While (hol^.kov<>Nil) and (hol^.kulcs<>k) do
      Begin
        elozo:=hol; Inc(kulcsHasonlitasok);
        Write(hol^.kulcs,','); hol:=hol^.kov;
      End;
      Write(hol^.kulcs);
      If hol^.kulcs=k then
      Begin
        van:=True; e:=hol^.kulcs {.elem}
      End
          Else
        van:=False;
      {EndIf};
      Inc(kulcsHasonlitasok,2);
      If
        van and (elozo=Nil) then {els elem}
                            Begin
                              Dec(t[i].db);
                              t[i].fej:=hol^.kov;
                              Dispose(hol);
                            End else if
        van                 then {nem els}
                            Begin
                              Dec(t[i].db);
                              elozo^.kov:=hol^.kov;
                              Dispose(hol);
                            End
      {EndIf};
    End;
    Writeln;
    sorDb:=WhereY
  End;

  Procedure TablabanKeres(t:Tabla; k:Kulcs; Var van:Boolean; Var e:Elem);
    Var
      i :Integer;
      te,
      hol:ListaElemMut;
  Begin
    If WhereY>=20 then UjLap('Tblzat -- keress tblban'+CrLf,-1); sorDb:=2;
    Write('Keresem a(z) "',k,'", ami a(z) ');
    i:=Hash(k);
    Writeln(i:5,'. index, ahol ',t[i].db,' elem van.');
    hol:=t[i].fej;
    If hol<>Nil then
    Begin
      Write('  Mgpedig: ');
      While (hol^.kov<>Nil) and (hol^.kulcs<>k) do
      Begin
        Inc(kulcsHasonlitasok);
        Write(hol^.kulcs,','); hol:=hol^.kov;
      End;
      Write(hol^.kulcs);
      If hol^.kulcs=k then
      Begin
        van:=True; e:=hol^.kulcs {.elem}
      End
          Else
        van:=False;
      {EndIf};
      Inc(kulcsHasonlitasok,2);
    End;
    Writeln;
    sorDb:=WhereY
  End;

Begin
  UjLap('Tblzat -- tblba flvtel'+CrLf,0); sorDb:=2;
  TablaUres(t);
  For i:=1 to BN do
  Begin
    nev:=RandomNev;
    Tablaba(t,nev);
  End;
  TablaKiir(t);
   {Keress:}
  UjLap('Tblzat -- keress tblban'+CrLf,-1); sorDb:=2;
  kulcsHasonlitasok:=0; sikerSzam:=0;
  For i:=1 to KN do
  Begin
    nev:=RandomNev;
    TablabanKeres(t,nev,siker,e);
    If siker then Inc(sikerSzam);
  End;
  Writeln(CrLf,' sszes keressi ksrletek szma:',KN);
  Writeln(' Sikerek szma:',sikerSzam);
  Writeln(' Kulcshasonltsok szma:',kulcsHasonlitasok);
   {Trls:}
  UjLap('Tblzat -- tblbl trls'+CrLf,-1); sorDb:=2;
  kulcsHasonlitasok:=0; sikerSzam:=0;
  For i:=1 to TN do
  Begin
    nev:=RandomNev;
    TablabolTorol(t,nev,siker);
    If siker then Inc(sikerSzam);
  End;
  Writeln(CrLf,' sszes trlsi ksrletek szma:',TN);
  Writeln(' Sikerek szma:',sikerSzam);
  Writeln(' Kulcshasonltsok szma:',kulcsHasonlitasok);
  TablaKiir(t);

{
  TablaKiir(t);
}

End.